//    23:13 07.02.2008

// (c) by Proteus 04.2003   lawnmower-man@mail.ru
//   IM  ( )
// 13.11.2007  
// 16.02.2009    

#define OS_WIN32 1 // .. wsock32.lib user32.lib /subsystem:console /incremental:yes 
#define OS_BEOS	2	// gcc icq3.cpp /system/lib/libbe.so -O1
#define OS_UNIX	3	// g++ icq3.cpp libpthread.so.0


#define _DEBUG 1

#ifdef _WIN32
#  define OS OS_WIN32
#endif
#ifdef __unix
#  define OS OS_UNIX
#endif
#ifdef __BEOS__
#  define OS OS_BEOS
#endif
#ifdef __QNX__
#  define OS OS_QNX
#endif

#define ICQ_IObufferSize 2000
#define ICQ_PSWbufferSize 30
#define SUBUIN 133575351	//  UIN
#define VERSION "Alpha"

#ifdef _DEBUG
#define TRACE(p) printf("%s\n",p);
#define DEBUG_FILE "icq_debug.log"
#else
#define TRACE(p) ;
#endif

#define FD_SETSIZE 1		//    select

//  

#include<stdio.h>
#include<time.h>
#include<string.h>
#include<stdlib.h>

#if OS == OS_WIN32
#  pragma warning(disable:4244)
#  pragma comment(lib,"ws2_32.lib")
#  include<windows.h>
#  include<winsock.h>
#  define THREAD_CALL ULONG _stdcall
#endif

#if OS == OS_BEOS
#  include<socket.h>
#  include<netdb.h>
#  include <Clipboard.h>
#  include <NetAddress.h>
#  define HOSTENT hostent
#  define PSOCKADDR sockaddr*
#  define IN_ADDR in_addr
#  define INADDR_NONE -1
#  define INVALID_SOCKET -1
#  define Sleep(n) snooze(n);
#  define ExitProcess(code) exit(code);
#  define GetTempPath(size,buffer) strcpy(buffer,"/tmp/");
#  define itoa(value,buffer,radix) sprintf(buffer,"%ld",(long)value)
#  define THREAD_CALL int32
 typedef uint8 BYTE;
 typedef uint16 WORD;
 typedef uint32 DWORD;
 typedef unsigned long ULONG;
 typedef int SOCKET;
#endif

#if OS == OS_UNIX
# include<netdb.h>
# include<pthread.h>
# include<stdlib.h>
# include<unistd.h>
# include<arpa/inet.h>
# include<sys/types.h>
# include<sys/socket.h>
# include<sys/stat.h>
# include<netinet/in.h>
# define THREAD_CALL void*
# define HOSTENT hostent
# define PSOCKADDR sockaddr*
# define IN_ADDR in_addr
# define INVALID_SOCKET -1
# define Sleep(n) usleep(n*1000);
# define ExitProcess(code) exit(code);
# define GetTempPath(size,buffer) strcpy(buffer,"/tmp/");
# define itoa(value,buffer,radix) sprintf(buffer,"%ld",(long)value)
# define closesocket(s) close(s)
 typedef u_int16_t WORD;
 typedef unsigned long ULONG;
 typedef u_int32_t DWORD;
 typedef u_int8_t BYTE; 
 typedef int SOCKET;
#endif

#if OS == QNX_OS
 typedef uint16_t WORD;
 typedef ulong ULONG;
 typedef uint32_t DWORD;
 typedef uint8_t BYTE; 
#endif


//   
class Profile {
	struct blank{char *key;char *value;blank *next;};
public:
	Profile();
	~Profile();
	void Load(char*);
	int ReadInt(char*,int def=0);
	void ReadString(char*,char*,int);
	void WriteInt(char*,int);
	void WriteString(char*,char*);
private:
	blank *Find(char*);
	char *name;
	blank *list;
};

Profile::Profile()
{list=0;}

Profile::~Profile()
{
	blank *temp;
	while(list) temp=list,list=list->next,delete[]temp->key,delete[]temp->value,delete temp;
}

void Profile::Load(char *filename)
{
	char buffer[256]; name=filename; char *ref; blank *temp; int n;
	FILE *file=fopen(filename,"rt");
	if(!file) return;
	while(!feof(file))
	{
		fgets(buffer,sizeof(buffer),file);
		n=strlen(buffer); while(n && buffer[n-1]<=' ') buffer[--n]=0;
		ref=strchr(buffer,'='); if(!ref) continue;
		*ref++=0; temp=new blank;
		temp->key=strdup(buffer); temp->value=strdup(ref);
		temp->next=list; list=temp;
	}
	fclose(file);
}

Profile::blank *Profile::Find(char *key)
{
	blank *temp=list;
	while(temp) {
		if(!strcmp(temp->key,key)) break;
		temp=temp->next;
	}
	if(!temp) {
		temp=new blank;
		temp->key=strdup(key);
		temp->value=strdup("");
		temp->next=list;
		list=temp;
	}
	return temp;
}

int Profile::ReadInt(char *key,int def)
{
	blank *res=Find(key);
	return res->value[0]?atoi(res->value):def;
}

void Profile::ReadString(char*key,char*buffer,int size)
{
	buffer[0]=0;
	blank *res=Find(key); 
	if((int)strlen(buffer)<size) strcpy(buffer,res->value);
}

void Profile::WriteString(char *key,char *value)
{
	blank *item=Find(key);
	delete[]item->value;
	item->value=strdup(value);
	FILE *file=fopen(name,"wt"); if(!file) return;
	item=list;
	while(item) fprintf(file,"%s=%s\n",item->key,item->value),item=item->next;
	fclose(file);
}

void Profile::WriteInt(char *key,int value)
{
	char buffer[13];
	itoa(value,buffer,10);
	WriteString(key,buffer);
}

#pragma pack(1)

struct ICQhead {char signature;char chanel;WORD sequence;WORD size;};
struct ICQsnac {WORD family;WORD type;WORD flag;WORD id;WORD type2;};
struct ICQpacket {ICQhead head;ICQsnac snac;};

//  

class ICQclient {
	void dump_in(); void dump_out();	//   
	struct arg_st {char*text;unsigned int n;};
public:
	ICQclient();
	void Online();	//    online  ( ,  +  )
private:
	void SaveAccount();				//  UIN+  
	DWORD ReadAccount(char*);		//  UIN+  
//   
	void InitSequence();			//    
	void MakeHead(char chanel=2);	//   
	ICQclient &MakeSnac(char,char);	//  SNAC 
	ICQclient &F(int);				//      
	ICQclient &A(char*,WORD);		// ...
	ICQclient &A(char,WORD,char*);  // .
	ICQclient &AS(char*,WORD);
	ICQclient &AC(char);
	ICQclient &AW(WORD);
	inline ICQclient &AW(WORD,WORD);
	ICQclient &AD(DWORD);
	ICQclient &AW_(WORD);
	ICQclient &AD_(DWORD);
	ICQclient &BUIN(DWORD);
	void GeneratePassword(char *);	//   
	void EncryptPassword(char *);	//    
	void ReturnOldAccount();		//    UIN     
//    
	ICQclient &operator > (WORD &w);	//     
	ICQclient &operator >>(BYTE &c);	//
	ICQclient &operator >>(WORD &w);	//
	ICQclient &operator >>(DWORD &d);	//
	char *GetMaxTLV(WORD code,int size); //  TLV    
	char *GetTLV(WORD code,int index=0); //   TLV      
	DWORD GetBUIN();	//  BUIN
//  
	bool Send();		//   (       )
	bool Recv(int offset=0); //       
	bool Connect(char *server="login.icq.com:5190");	//    
	static SOCKET Connect(char *server,WORD port);	//      ,  
	void Disconnect();		//   
	void TurndownConnect(bool);	//     
//   
	bool Login();	//   
	void Work();	//   (  )
	bool Parser();	//         
	bool Parse_Message();	//    
	bool Send_MyNick();		//  
	bool SetAuthorizationMode();	//   

	bool Output_Message(DWORD uin,char *text);	//      UIN
	bool Output_DeniedMessage(DWORD uin);		//     
	bool Output_Version(DWORD uin);	//      
// command s
	bool Cmd_Help(DWORD uin);
	bool Cmd_Pong(DWORD uin,arg_st*,unsigned int);
	bool Cmd_SetStatus(DWORD uin,arg_st*data,unsigned int count);
	bool Cmd_Statistic(DWORD uin);
	bool Cmd_Version(DWORD uin);
	bool Cmd_Body(DWORD uin,char*);
// data
	WORD snac_id,sequence;	//    
	SOCKET s;
	Profile config;
	union { ICQpacket in_packet; char in_buffer[ICQ_IObufferSize];}; unsigned int in_index,in_size,in_allsize;
	union { ICQpacket out_packet; char out_buffer[ICQ_IObufferSize];}; unsigned int out_index;
// options
	int OUT_traffic,IN_traffic;
	DWORD m_subUIN;		//  UIN
	DWORD m_myUIN;		//  UIN
	char m_myNick[30];	// 
	char m_myMail[30];	//  
	char m_myPass[ICQ_PSWbufferSize];	//  
// vars
	int m_ping_time;		//   (0 -   )
	int m_connect_delay;	//  
	int m_login_delay,m_isLogin_delay;	//   (     .)
	time_t m_last_connect; //   
	int m_login_try_count; //   
};

//  

void ICQclient::dump_out( )
{
#ifdef _DEBUG
	FILE *file=fopen(DEBUG_FILE,"at");
	printf("\nClient\n"); unsigned int m,l,n=0;
	fprintf(file,"\nClient\n");
	while(n<out_index) {
	l=n+16; if(l>out_index) l=out_index;
	for(m=n;m<l;m++) printf("%02X ",255&(int)out_buffer[m]),fprintf(file,"%02X ",255&(int)out_buffer[m]);
	for(;m<n+16;m++) printf("   "),fprintf(file,"   ");
	for(m=n;m<l;m++) if(out_buffer[m]<' ' || out_buffer[m]>126) putchar('.'),fputc('.',file); else putchar(out_buffer[m]),fputc(out_buffer[m],file);
	n+=16; putchar('\n'),fputc('\n',file);}
	fclose(file);
#endif
}


void ICQclient::dump_in()
{
#ifdef _DEBUG
	FILE *file=fopen(DEBUG_FILE,"at");
	printf("\nServer:\n"); unsigned int m,l,n=0;
	fprintf(file,"\nServer\n");
	while(n<in_size) {
	l=n+16; if(l>in_size) l=in_size;
	for(m=n;m<l;m++) printf("%02X ",255&(int)in_buffer[m]),fprintf(file,"%02X ",255&(int)in_buffer[m]);
	for(;m<n+16;m++) printf("   "),fprintf(file,"   ");
	for(m=n;m<l;m++) if(in_buffer[m]<' ' || in_buffer[m]>126) putchar('.'),fputc('.',file); else putchar(in_buffer[m]),fputc(in_buffer[m],file);
	n+=16; putchar('\n'),fputc('\n',file);}
	fclose(file);
#endif
}

//     ...  ....

//  

ICQclient::ICQclient()
{
	in_size=0; IN_traffic=OUT_traffic=0; tm *ltime; time_t Time;
#ifdef _DEBUG
	FILE *file=fopen(DEBUG_FILE,"wt"); fclose(file); //   
#endif
	config.Load("icq.ini"); time(&Time); ltime=gmtime(&Time);
	m_connect_delay=m_login_delay=0; m_last_connect=time(0);
	m_ping_time =config.ReadInt("ping");
	m_subUIN    =config.ReadInt("sub",SUBUIN);
	m_myUIN     =ReadAccount(m_myPass);
	m_login_try_count=0;
	gethostname(m_myNick,sizeof(m_myNick));
	config.ReadString("email",m_myMail,sizeof(m_myMail));
	config.ReadString("nick",m_myNick,sizeof(m_myNick));
}

void ICQclient::GeneratePassword(char *output)
{
	srand(time(0)); char sym; unsigned int n,size=9-(rand()&3);
	for(n=0; n<size; n++) {
		sym=(char)(rand()%('z'-'a'+11));
		sym+=(sym>9)?'a'-10:'0';
		output[n]=sym;
	}
	output[n]=0;
}

void ICQclient::EncryptPassword(char *pass)
{ 
	const BYTE Xor[]={0xF3,0x26,0x81,0xC4,0x39,0x86,0xDB,0x92,0x71,0xA3,0xB9,0xE6,0x53,0x7A,0x95,0x7C};
	int Index=0; strcpy(pass,m_myPass);
	while(*pass) *pass++^=Xor[Index],Index=(Index+1)&15;
}


//    uin
DWORD ICQclient::ReadAccount(char *buffer)
{
	config.ReadString("pass",buffer,ICQ_PSWbufferSize);
	return config.ReadInt("uin");
}


void ICQclient::SaveAccount()
{
	config.WriteInt("uin",m_myUIN);
	config.WriteString("pass",m_myPass);
}


//     

ICQclient &ICQclient::F(int count)
{
	while(count--) AC(0); return *this;
}

ICQclient &ICQclient::A(char *line,WORD size)
{
	while(size--) AC(*line++); return *this;
}

ICQclient &ICQclient::A(char code,WORD size,char*line)
{
	return AW(code,size).A(line,size);
}

ICQclient &ICQclient::AS(char *line,WORD size)
{
	return AW_(size).A(line,size);
}

ICQclient &ICQclient::AC(char n)
{
	if(out_index<sizeof(out_buffer)) out_buffer[out_index++]=n; return *this;
}

ICQclient &ICQclient::AW(WORD w)
{
	return AC(w>>8).AC(w);
}

ICQclient &ICQclient::AW(WORD a,WORD b)
{
	return AD(b+65536*(DWORD)a);
}


ICQclient &ICQclient::AD(DWORD d)
{
	return AW(d>>16).AW(d);
}

ICQclient &ICQclient::AW_(WORD w)
{
	AC(w).AC(w>>8); return *this;
}

ICQclient &ICQclient::AD_(DWORD d)
{
	AC(d).AC(d>>8).AC(d>>16).AC(d>>24); return *this;
}

ICQclient &ICQclient::BUIN(DWORD uin)
{
	char buffer[13]; itoa(uin,buffer,10); unsigned int len=strlen(buffer);
	if(out_index<sizeof(out_buffer)-3) AC(len).A(buffer,len); return *this;
}

ICQclient &ICQclient::operator > (WORD &w)
{
	w=*(WORD*)&in_buffer[in_index]; in_index+=2;
	return *this;
}

ICQclient &ICQclient::operator >> (BYTE &c)
{
	c=in_buffer[in_index++];
	return *this;
}

ICQclient &ICQclient::operator >> (WORD &w)
{
	*this>w; w=(w<<8)|(w>>8);
	return *this;
}

ICQclient &ICQclient::operator >> (DWORD &d)
{
	WORD w;	*this>>w; d=w; *this>>w; d=d<<16|(65535&w);
	return *this;
}

void ICQclient::InitSequence()
{
	DWORD n=rand(),s=0;
	for(DWORD i=n; i>>=3; s-=i);
	sequence=((n^s)&7^n)+2;
}

//     

void ICQclient::MakeHead(char chanel)
{
	out_packet.head.signature='*';
	out_packet.head.chanel=chanel;
	out_packet.head.sequence=sequence>>8|sequence<<8;
	out_index=sizeof(ICQhead);
	sequence++;
}

ICQclient &ICQclient::MakeSnac(char family,char type)
{
	MakeHead();
	out_packet.snac.family=family<<8;
	out_packet.snac.type=type<<8;
	out_packet.snac.flag=0;
	out_packet.snac.id=0;
	out_packet.snac.type2=out_packet.snac.type;
	out_index=sizeof(ICQpacket);
	return *this;
}

char *ICQclient::GetTLV(WORD code,int offset)
{
	in_index=sizeof(ICQpacket)+offset; WORD type,size;
	while(in_index<in_size-4) {
		*this>>type>>size;
		if(type==code) return in_buffer+in_index;
		in_index+=size;
	}
	return 0;
}

DWORD ICQclient::GetBUIN()
{
	BYTE count,sym; *this>>count; DWORD uin=0;
	while(count--) *this>>sym,uin=uin*10+sym-'0';
	return uin;
}

//   

bool ICQclient::Send()
{
	unsigned int m=0; int n;
	WORD size=out_index-sizeof(ICQhead);
	out_packet.head.size=size<<8|size>>8;
	dump_out();
	while(m<out_index)
	{
		n=send(s,out_buffer+m,out_index-m,0); if(n==-1) { TurndownConnect(false); Disconnect(); return true;}
		OUT_traffic+=n; m+=n;
	} config.WriteInt("out",OUT_traffic);
	return false;
}

bool ICQclient::Recv(int offset)
{
	for(;;) { 
		if(!m_ping_time) break;
		timeval tm; fd_set set;
		tm.tv_usec=0; tm.tv_sec=m_ping_time;
		FD_ZERO(&set);
		FD_SET(s,&set);
		if(select(-1,&set,0,0,&tm)) break;
		MakeHead(5);
		if(Send()) return true;
	}
	int n=recv(s,in_buffer+offset,sizeof(in_buffer)-offset,0);
	if(n==-1) { TurndownConnect(false); Disconnect(); return true;}
	IN_traffic+=n; in_allsize=in_size=offset+n;
	dump_in(); config.WriteInt("in",IN_traffic);
	return false;
}

SOCKET ICQclient::Connect(char *server,WORD port)
{
	SOCKET s=INVALID_SOCKET; sockaddr_in addr;
	HOSTENT *ph; ULONG iaddr; 
	iaddr = inet_addr(server);
	if (iaddr == INADDR_NONE)
	{	
		ph = gethostbyname(server); if(!ph) return s;
		memcpy(&addr.sin_addr,ph->h_addr_list[0],sizeof(IN_ADDR));
	}else memcpy(&addr.sin_addr,&iaddr,4);
	addr.sin_family = AF_INET;
	addr.sin_port   = htons(port);
	s=socket(AF_INET,SOCK_STREAM,0); if(s==INVALID_SOCKET) return s;
	if(connect(s,(PSOCKADDR)&addr,sizeof(addr))) closesocket(s),s=INVALID_SOCKET;
	return s;
}

bool ICQclient::Connect(char *server)
{
#ifdef _DEBUG
	FILE *file=fopen(DEBUG_FILE,"at"); if(file)
	fprintf(file,"\nAttempt of connect\n"),fclose(file);
#endif
	char *S_addr; char *S_port; 
	TRACE("connect"); m_last_connect=time(0);
	if(!strchr(server,':')) return true;
	S_addr=strdup(server); S_port=strchr(S_addr,':'); *S_port++=0;
	s=Connect(S_addr,atoi(S_port)); delete[]S_addr;
	if(s==INVALID_SOCKET) { TurndownConnect(false); return true;}
	else { m_connect_delay=0; return false;}
}

void ICQclient::Disconnect()
{
	if(s!=INVALID_SOCKET) closesocket(s); s=INVALID_SOCKET;
}

   //     
   // exp ==true    +   
void ICQclient::TurndownConnect(bool exp)
{
	if(exp) { if(m_login_delay<3500) m_login_delay+=m_login_delay/2+1,m_isLogin_delay=true; m_login_try_count++;}
	   else { if(m_connect_delay<70) m_connect_delay+=7;}
}

//////
//   


//    
//        
bool ICQclient::Login()
{
	const BYTE data2[]={
		0,1,0,3,1,0x10,2,0x8A,
		0,4,0,1,1,0x10,2,0x8A,
	}; // 
	const BYTE data3[]={0,0,0,1, 0,1, 0};
	char buffer[20]; char *addr,*sock,*temp1,*temp2; WORD size1,size2;
	sequence=0;
	//InitSequence();
	if(Connect()||Recv()) 
		return true;
	EncryptPassword(buffer); MakeHead(1); 
	A((char*)data3,sizeof(data3)).BUIN(m_myUIN).A(2,strlen(m_myPass),buffer).A(15,2,"ru");
	if(Send()||Recv()) return true; 
	TurndownConnect(true);
	if(GetTLV(8,-(int)sizeof(ICQsnac))) {
		*this>>size1; //   
		switch(size1) {
		case 0x05:
		case 0x1D: m_myPass[0]=0; break;	//  
		case 0x18: if(m_login_delay<200) m_login_delay=200; break; //    (  200   )
		}
		return true;
	}
	if(GetTLV(4,-(int)sizeof(ICQsnac))) return true;
	m_login_try_count++;
	temp1=GetTLV(5,-(int)sizeof(ICQsnac)); if(!temp1) return true; in_index-=2; *this>>size1;
	temp2=GetTLV(6,-(int)sizeof(ICQsnac)); if(!temp2) return true; in_index-=2; *this>>size2;
	try{
		addr=new char[size1+1]; memcpy(addr,temp1,size1); addr[size1]=0;
		sock=new char[size2]; memcpy(sock,temp2,size2);
		MakeHead(4); if(Send()) throw(true); Disconnect();
		if(Connect(addr)||Recv()) throw(true);
		MakeHead(1); AD(1).A(6,size2,sock);
		if(Send()||Recv()) throw(true);
		MakeSnac(1,2).A((char*)data2,sizeof(data2));
		throw(Send());
	}
	catch(bool res)
	{
		delete[]addr; delete[]sock; if(res) Disconnect();
		return res;
	}
}


bool ICQclient::Send_MyNick() // set my info  (nick+email)
{
	int len=strlen(m_myNick)+1; int mlen=strlen(m_myMail)+1;
	MakeSnac(0x15,2).AW(1,len+mlen+38).AW_(len+mlen+36).AD_(m_myUIN).AW(0xD007,sequence).AW(0xEA03).AS(m_myNick,len).AD(0).AS(m_myMail,mlen).F(14).AW(0x700,0);
	return Send();
}

bool ICQclient::SetAuthorizationMode()
{
	MakeSnac(0x15,2).AW(1,16).AW_(14).AD_(m_myUIN).AW(0xD007,sequence).AW(0x2404,0x0101).AW(0x0100); //   
	return Send();
}

void ICQclient::Online()
{
	if(!m_myUIN) m_myPass[0]=0;
	for(;;) {
		if(m_login_try_count>300) break;
		for(;;)
		{
			int t=(int)(time(0)-m_last_connect);
			if(t>=m_connect_delay && t>=m_login_delay) break;
#ifdef _DEBUG
			printf("Delay (%d,%d,%d)\r",(int)t,(int)m_login_delay,(int)m_connect_delay);
#endif
			Sleep(301);
		}
		if(!m_myPass[0]) {
			TRACE("undef UIN/PASS");
			SaveAccount();
			return;
		}
		if(Login()) continue;
		if(Send_MyNick()) continue;
		if(SetAuthorizationMode()) continue;
		Work();
	}
}

//////////////////////

bool ICQclient::Parse_Message()
{
const char *list[]={
	"help",
	"ping",
	"statistic",
	"version",
	"set-status",
	"body",
	0
	};
	WORD temp,size; char buffer[1024]; char *data;
	in_index=sizeof(ICQpacket)+8;
	*this>>temp; DWORD uin=GetBUIN(); in_index=in_index+4-sizeof(ICQpacket);
	switch(temp) {
	case 1:	
		data=GetTLV(2,in_index); if(!data) return false; //     -  ,         -    
		data=GetTLV(0x101,in_index-sizeof(ICQpacket)); if(!data) return false;
		in_index-=2; *this>>size; in_index+=4; break;
	case 4:	
		for(;;){
			data=GetTLV(5,in_index); 
			if(!data) return false;
			in_index-=2;*this>>size;
			if(size>9) break;
			in_index+=size;
		}
		in_index+=6;
		*this>size;
		break;
	default:
		sprintf(buffer,"[%d] Incorect message from: %d\n",(int)temp,(int)uin);
		return Output_Message(uin,buffer);
	}
#ifdef DEBUG_
	printf("Incominc message from %d\n%s\n\n",uin,data);
#endif
	char *ref=data=in_buffer+in_index; if(ref+size>in_buffer+in_size) return false;

	int l,n,count=0; unsigned char sym,old=' '; temp=size;
	while(temp--) {
		*this>>sym; if(old<=' ' && sym>' ') count++;
		if(sym==13 || !sym) break; old=sym;}
	if(!count) return false;
	char *body=ref;	
	while((BYTE)*body>=' ') body++;
	while(*body && (BYTE)*body<' ') body++;
	arg_st *stack,*stack1; stack=new arg_st[count]; ref=data;
	for(n=0; n<count; n++)
	{
		while((BYTE)*data<=' ' && size) data++,size--; ref=data;
		while((BYTE)*data>' ' && size ) data++,size--; l=data-ref;
		stack[n].text=new char[l+1]; memcpy(stack[n].text,ref,l); stack[n].text[l]=0;
	}; 
	data[size-1]=0;
	for(n=0; n<count; n++) stack[n].n=atoi(stack[n].text);
	for(n=0; list[n]; n++) if(!strcmp(list[n],stack[0].text)) break;
#ifdef _DEBUG
	printf("Command id=%d\n",n);
#endif
	bool res=false; 
	count--; stack1=stack+1; switch(n) {
	case 0: res=Cmd_Help(uin); break;
	case 1: res=Cmd_Pong(uin,stack1,count); break;
	case 2: res=Cmd_Statistic(uin); break;
	case 3: res=Cmd_Version(uin); break;
	case 4: res=Cmd_SetStatus(uin,stack1,count); break;
	case 5: res=Cmd_Body(uin,body); break;
	case 6: res=Output_Message(uin,"#$%"); break;
	}
	for(n=0; n<count; n++) delete[]stack[n].text;
	delete[]stack;
	return res;
}


bool ICQclient::Output_Version(DWORD uin)
{
	return Output_Message(uin,"ICQ system\nVersion: " VERSION "\n");
}


bool ICQclient::Output_Message(DWORD uin,char *text)
{
	int len=strlen(text)+1;
	MakeSnac(4,6).F(8).AW(4).BUIN(uin).AW(5,len+8).AD_(m_myUIN).AW(0x0100).AS(text,len).A(6,0,0);
	return Send();
}

bool ICQclient::Output_DeniedMessage(DWORD uin)
{
	return Output_Message(uin,"Access denied!");
}

/////
//   

void ICQclient::Work()
{
	in_allsize=in_size=0; WORD n;
	for(;;) {
		if(!in_allsize && Recv(in_allsize)) return;
		n=in_packet.head.size; in_size=sizeof(ICQhead)+(n>>8)|(WORD)(n<<8);
		if(in_size>in_allsize) continue;
		if(Parser()) return;
		if(in_size<in_allsize) memcpy(in_buffer,in_buffer+in_size,in_allsize-in_size);
		in_allsize-=in_size;
	}

}

//   
bool ICQclient::Parser()
{
	in_index=sizeof(ICQpacket);
	if(in_packet.head.signature!='*') return true;
	switch(in_packet.head.chanel) {
	case 2: break;
	case 1:	case 4: return true;
	default: return false;
	}
	switch(in_packet.snac.family){
	case 0x0400: if(in_packet.snac.type!=0x700) break; return Parse_Message();
	}
	return false;
}


// 

//=====  

//   (   )
bool ICQclient::Cmd_Help(DWORD uin)
{
	return Output_Message(uin,
	"[list of active commands]\n\n"
	"ping [<user_word>]\n"
	"set-status online|free|away|n/a|occupied|dnd|invisible\n"
	"statistic\n"
	"version\n"
	"body\n"
	);
}

//    pong (   )
bool ICQclient::Cmd_Pong(DWORD uin,arg_st*data,unsigned int count)
{
	char buffer[100];
	strcpy(buffer,"pong"); if(count && strlen(data[0].text)<93) strcat(buffer," "),strcat(buffer,data[0].text);
	return Output_Message(uin,buffer);
}

//   (    )
bool ICQclient::Cmd_SetStatus(DWORD uin,arg_st*data,unsigned int count)
{
	if(uin!=m_subUIN) return Output_DeniedMessage(uin);
const char *list[]={"online","free","invisible","away","n/a","occupied","dnd",0};
const WORD id[]={0,0x20,0x100,1,5,0x11,0x13}; unsigned int n;
	if(count!=1) return false;
	for(n=0;;n++) {
		if(!list[n]) return Output_Message(uin,"Unknown status");
		if(!strcmp(list[n],data[0].text)) break;}
	MakeSnac(1,0x1E).AW(6,4).AD((DWORD)id[n]);
	return Send();
}

//   
bool ICQclient::Cmd_Statistic(DWORD uin)
{
	char buffer[100];
	sprintf(buffer,"[Stacistics]\nin traffic: %d\nout traffic: %d\ntotal: %dk",IN_traffic,OUT_traffic,(IN_traffic+OUT_traffic)/1024);
	return Output_Message(uin,buffer);
}

//  
bool ICQclient::Cmd_Version(DWORD uin)
{
	return Output_Version(uin);
}

//        (    )
bool ICQclient::Cmd_Body(DWORD uin,char *body)
{
	return Output_Message(uin,body);
}


int main()
{
	TRACE("Start...\n");
#if OS == OS_WIN32
	WSADATA wsa; WSAStartup(0x202,&wsa);
#endif
	ICQclient icq;
	icq.Online();
	return 0;
}


